<?php
//program TESTED and RUN on: Manjaro Linux 23.1, PHP 8.2, MariaDB 11:
//edit: config.php for database login data...
//commands: cd my_dir_with_code_index.php [enter], then: php -S localhost:8080, then open browser at address localhost:8080/index.php or install.php

//---------------------------------------------------------------------------------
//database login data:
$servername = "localhost";
$username = "azet";
$password = "heslo";
$database="azet";

//---------------------------------------------------------------------------------

//some consts for program:
  //for nick there is a constraint in install.php in DATABASE where nick is 59 chars long
$MAX_LEN_NICK=12; //maximum allowed length for nicks to enter the chat (in db max 59 chars)
$MAX_LEN_MSG=180; //max chars allowed in msg in chat
$GLASS_MAX_MSGS=20; //max visible messages on the glass page chat.php
$MAX_GLASS_LIMIT_DB=23; //how many messages can be internally in database stored for web glass chat.php
$MAX_CHATTERS_ALLOWED=50; //I have server with maximum allowed people in chat 50 with 128MB memory allowed
$MAX_RP_COUNT_ALLOWED=20; //how many RPs msgs are allowed to show from db table rp in opened thread with RP msgs
$MAX_LEN_MSG_RP=180; //max length in chars of one RP message in rp.php when sending rp in input field
//you must stay logged ad least some time, coz if you delete nick eg after second, you also delete RP_msgs and whole your glass msgs:
$MAX_TIME_BEING_LOGGED_ON=3601; //in seconds how long to stay logged before system deletes your nick from users->glass->rp tables

//---------------------------------------------------------------------------------

//function trying to open connection with database mariadb or mysql returns $conn
function open_conn_with_db($servername,$username,$password,$database){
    try{
    $conn = mysqli_connect($servername, $username, $password);
// Check connection
if (!$conn) {
  die(" <br>Connection failed: " . mysqli_connect_error());
}else{
    $db_selected = mysqli_select_db($conn,$database);
    if(!$db_selected){
        die("<br>Could not select database: " . mysqli_connect_error());
    }else{
        echo(" <br>Database selected successfully.");
    }
}
echo(" <br>Connected successfully");

return $conn;
}catch(Exception $e){
    echo("<br>Error opening connection: ".$e);
    exit("<br>STOPPING EXECUTION OF SCRIPTS, REPAIR THIS ERROR...");
}
}


//function trying to open connection QUIETELY with database mariadb or mysql returns $conn
function open_conn_with_db_quietly($servername,$username,$password,$database){
    try{
    $conn = mysqli_connect($servername, $username, $password);
// Check connection
if (!$conn) {
  die(" <br>Connection failed: " . mysqli_connect_error());
}else{
    $db_selected = mysqli_select_db($conn,$database);
    if(!$db_selected){
        die("<br>Could not select database: " . mysqli_connect_error());
    }else{
        //echo(" <br>Database selected successfully.");
    }
}
//echo(" <br>Connected successfully");

return $conn;
}catch(Exception $e){
    echo("<br>Error opening connection: ".$e);
    exit("<br>STOPPING EXECUTION OF SCRIPTS, REPAIR THIS ERROR...");
}
}

//based on connection you can run query $sql for database with $conn handle connection
function run_query($sql,$conn){
    try{
    if (mysqli_query($conn, $sql)) {
        echo("<br>Query created successfully<br>".$sql);
      } else {
        echo("Error creating query: " . mysqli_error($conn));
      }
    }catch(Exception $e){
        echo("<br>Error running query: ".$sql." <br>Exception is: ".$e);
        exit("<br>STOPPING EXECUTION OF SCRIPTS, REPAIR THIS ERROR...");
    }
}

//based on connection you can run QUIETLY query $sql for database with $conn handle connection
//if query is successful the func returns result else -1:
function run_query_quietly($sql,$conn){
    try{
        $result=mysqli_query($conn, $sql);
    if ($result) {
        //echo("<br>Query created successfully<br>".$sql);
        return $result;
      } else {
        //echo("Error creating query: " . mysqli_error($conn));
        return -1;
      }
    }catch(Exception $e){
        echo("<br>Error running query: ".$sql." <br>Exception is: ".$e);
        exit("<br>STOPPING EXECUTION OF SCRIPTS, REPAIR THIS ERROR...");
    }
}

//function to check chars and length allowed in nick, returns bool true if ok else false
function check_nick_len_allow($nick,$MAX_LEN_NICK){
    if(trim($nick)==0) return 0;
    $nick=substr(trim($nick),0,$MAX_LEN_NICK);
    $pattern = "/^[A-Za-z0-9_]+$/";
    return preg_match($pattern, $nick);
}

//check max lenght and allowed chars in chat.php message: returns true if ok
function check_msg_len_allow($msg,$MAX_LEN_MSG){
    $msg=substr(trim($msg),0,$MAX_LEN_MSG);
    if(trim($msg)==0) return 0;
    if(substr_count($msg, '\n')>0) return 0;
    if(substr_count($msg, ' ')<15 && strlen($msg)>178) return 0;
    if(substr_count($msg, ' ')<10 && strlen($msg)>138) return 0;
    if(substr_count($msg, ' ')<9 && strlen($msg)>100) return 0;
    if(substr_count($msg, ' ')<5 && strlen($msg)>50) return 0;
    if(substr_count($msg, ' ')<3 && strlen($msg)>=30) return 0; //if msg is longer than 30 chars and sentence has less than 3 spaces
    
    
    $pattern = "/^[a-zA-Z0-9_ ]*$/";
    if(!preg_match($pattern, $msg)) return 0;else return 1;
    
}

//question of captcha returns day from 1 to 7 in the week to guess for:
function captcha_question(){
    $day=rand(1,7);
    if($day==1) echo("pondelok");
    if($day==2) echo("utorok");
    if($day==3) echo("streda");
    if($day==4) echo("štvrtok");
    if($day==5) echo("piatok");
    if($day==6) echo("sobota");
    if($day==7) echo("nedeľa");
    return $day;
}

//check captcha:
//if the answer of captcha is ok, then returns 1 else returns 0:
function captcha($question,$answer){
    if($question==$answer) return 1; else return 0;
}

//returns nums of captcha based on strings:
function parse_captcha($s){
    if(trim($s)=='') return 0;
    if(trim($s)=='1') return 1;
    if(trim($s)=='2') return 2;
    if(trim($s)=='3') return 3;
    if(trim($s)=='4') return 4;
    if(trim($s)=='5') return 5;
    if(trim($s)=='6') return 6;
    if(trim($s)=='7') return 7;
}

//generate lines of messages from DB table glass on the glass of webpage:
function generate_chat_lines($servername,$username,$password,$database,$GLASS_MAX_MSGS,$MAX_GLASS_LIMIT_DB,$MAX_HRS_GLASS_NICK){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
            if(isset($_SESSION["nick"]) && strlen(trim($_SESSION["nick"]))>0){
                

                $sql="select from_id, time3, msg3 from glass ORDER BY time3 DESC LIMIT ".strval($GLASS_MAX_MSGS);
                $result=run_query_quietly($sql,$conn);
                $lines_generated=array();
                $iter=1;
                if (mysqli_num_rows($result) > 0) {
                    // output data of each row
                    while($row = mysqli_fetch_assoc($result)) {
                        $from_id=$row["from_id"];
                        $msg3=trim($row["msg3"]);
                        $time3=$row["time3"];
                        $sql2="select nick from users WHERE id=".$from_id." LIMIT 1 ";
                        $result2=run_query_quietly($sql2,$conn);
                        $nick3="";
                        if (mysqli_num_rows($result2) > 0) {
                            // output data of each row
                            while($row2 = mysqli_fetch_assoc($result2)) {
                                $nick3=$row2["nick"];

                                //lets update time stamp of every logged user to know dead ends
                                //coz dead ends closed window and are not refreshing window
                                if(trim($_SESSION["nick"])==$nick3){
                                    $sql8="update users set time1=CURRENT_TIMESTAMP where id=".$from_id." LIMIT 1";//update current timestamp of nick if he writes anything or if effortless logout
                                    $result8=run_query_quietly($sql8,$conn);
                                }

                            }
                        }else{
                            $lines_generated[]="<div style=\"width:100%; background-color:red;color:white;\">Problém s párovaním primárneho a cudzieho kľúča pre from_id/id glass/users: ".strval($from_id)."</div>";
                        }
                        if($iter%2==0){
                            $lines_generated[]="<div style=\"width:100%; background-color:yellow;\">".$time3." | ".$nick3." | ".$msg3." </div>";
                        }else{
                            $lines_generated[]="<div style=\"width:100%; background-color:lightgreen;\">".$time3." | ".$nick3." | ".$msg3." </div>";
                        }
                        $iter+=1;
                    }
                    
                }
            }
            mysqli_close($conn);
            $lines_stringified="";
            for($i=0;$i<=count($lines_generated)-1;$i++){
                $lines_stringified.=$lines_generated[$i];
            }
            //here always after refresh of glass we check if database has more than 100 lines of texts and we can flush table glass
            delete_full_glass($servername,$username,$password,$database,$MAX_GLASS_LIMIT_DB);
            //also here delete users whose time stamp is more than 2 hrs:
            //delete_old_time_stamps($servername,$username,$password,$database,$MAX_HRS_GLASS_NICK);

    return $lines_stringified;
}

//delete full glass:
function delete_full_glass($servername,$username,$password,$database,$MAX_GLASS_LIMIT_DB){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    $sql="select msg3 from glass";
    $result=run_query_quietly($sql,$conn);
        
    if (mysqli_num_rows($result) > $MAX_GLASS_LIMIT_DB) {
        $sql="delete from glass";
        $result=run_query_quietly($sql,$conn);
    }
    
    mysqli_close($conn);
}

//delete chain on logout: so we do not do garbage collecting after 2hrs, but only on logout of user
//we do not wanna any dead ends in database so doing this:
function delete_chain_on_logout($servername,$username,$password,$database,$MAX_TIME_BEING_LOGGED_ON){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    $sql="select id,timestampdiff(SECOND,time1,CURRENT_TIMESTAMP)<".$MAX_TIME_BEING_LOGGED_ON." as bool1 from users";    
    $result=run_query_quietly($sql,$conn);
    if (mysqli_num_rows($result) > 0) {
        while($row = mysqli_fetch_assoc($result)) {

            if($row["bool1"]==0){
                $sql2="DELETE from users WHERE id=".$row["id"]."";
                $result2=run_query_quietly($sql2,$conn);
                $sql3="DELETE from glass WHERE from_id=".$row["id"]."";
                $result3=run_query_quietly($sql3,$conn);
                $sql4="DELETE from rp WHERE from_id=".$row["id"]."";
                $result4=run_query_quietly($sql4,$conn);
                $sql5="DELETE from rp WHERE to_id=".$row["id"]."";
                $result5=run_query_quietly($sql5,$conn);//end of deletion chain on log out of user from main glass webpage chat.php
            }
        }
    }


    
    mysqli_close($conn);
}

//HOMEWORK TO THINK ABOUT: HOW TO IMPLEMENT THIS AVG:
//check how long to erase dead ends in average:
function how_long_dead_ends_avg($servername,$username,$password,$database,$MAX_TIME_BEING_LOGGED_ON){
    
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    $sql="select id,timestampdiff(SECOND,time1,CURRENT_TIMESTAMP)<".$MAX_TIME_BEING_LOGGED_ON." as bool1 from users";    
    $result=run_query_quietly($sql,$conn);
    $avg=0;
    $iter0=0;
    $iter1=0;
    if (mysqli_num_rows($result) > 0) {
        
        while($row = mysqli_fetch_assoc($result)) {

            if($row["bool1"]==0){//we need to erase dead end
                $iter0+=1;    
            }
            if($row["bool1"]==1){//we dont need to erase dead end
                $iter1+=1;
            }
        }
        if($iter1==0 || $iter0==0) ;else $avg=round(($iter1/($iter1+$iter0))*$MAX_TIME_BEING_LOGGED_ON);
        return "";
    }


    
    mysqli_close($conn);
    return "";
}

//function returns 1 if he has a new RP from this nick:
function does_he_have_rp($nick,$servername,$username,$password,$database){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    if(isset($_SESSION["nick"]) && strlen(trim($_SESSION["nick"]))>0){//only if you are logged in you can see others in chat
        $sql="select id from users WHERE nick='".trim($_SESSION["nick"])."' LIMIT 1";//everywhere limit, if anybody breaks session he gets only 1 result from db
        $result=run_query_quietly($sql,$conn);
        $session_nick_id=-1;
        if (mysqli_num_rows($result) > 0) {
            while($row = mysqli_fetch_assoc($result)) {
                $session_nick_id=$row["id"];
            } 
        }else {
            return 0; //if we are on error with gettin session nick id in db, we return zero RPs
        }

        $sql="select id, nick from users WHERE nick='".trim($nick)."' LIMIT 1";//everywhere limit, if anybody breaks session he gets only 1 result from db
        $result=run_query_quietly($sql,$conn);
        $this_nick_id=-1;
        if (mysqli_num_rows($result) > 0) {
            while($row = mysqli_fetch_assoc($result)) {
                $this_nick_id=$row["id"];

                //lets update time stamp of every logged user to know dead ends
                                //coz dead ends closed window and are not refreshing window
                                if(trim($_SESSION["nick"])==$row["nick"]){
                                    $sql8="update users set time1=CURRENT_TIMESTAMP where id=".$row["id"]." LIMIT 1";//update current timestamp of nick if he writes anything or if effortless logout
                                    $result8=run_query_quietly($sql8,$conn);
                                }

            } 
        }else {
            return 0; //if we are on error with gettin this nick id in db, we return zero RPs
        }

        $sql="select msg2 from rp where to_id=".$session_nick_id." and seen='0' and from_id=".$this_nick_id." LIMIT 100";//everywhere limit, if anybody breaks session he gets only 1 result from db
        $result=run_query_quietly($sql,$conn);
        $iter=0;
        if (mysqli_num_rows($result) > 0) {
            return mysqli_num_rows($result); //returns how many RPs $nick has for $SESSION[nick]
        }else {
            return 0; //if we are on error with gettin this nick id in db, we return zero RPs
        }



    }
    mysqli_close($conn);
    return 0; //TODO: check rp table for rp_s from this nick towards SESSION[nick]
    //remark for present db test: INSERT INTO rp (from_id,to_id,msg2,seen) VALUES (21,22,'nick2 pise nick3','0');
    //remark dead end on RP==lost session==opposite side logged out/closed browser
    //remark: on logout dead ends occur, so after refresh minutes garbage collector must erase all id in users older than 2hrs now-t_stamp 
                //of them also all from_id/to_id in rp based on these id and also all msg3 in glass based on these id
                //or lets erase these 3 tables dependencies on logout in chat.php: users->glass->rp chained deletion
}

//function that generates all nicks on the right side of the glass chat.php with possibility to open RP msg
function generate_nick_lines($servername,$username,$password,$database,$MAX_CHATTERS_ALLOWED,$MAX_TIME_BEING_LOGGED_ON){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
            if(isset($_SESSION["nick"]) && strlen(trim($_SESSION["nick"]))>0){//only if you are logged in you can see others in chat
                $sql="select nick, time1 from users ORDER BY nick DESC LIMIT 60";
                $result=run_query_quietly($sql,$conn);
                if (mysqli_num_rows($result) > $MAX_CHATTERS_ALLOWED) {
                    return "<a style=\"color:blue;\" href=\"chat.php?odhlasit=true\"> Už sa nezmestíš do pokecu, KLIKNI SEM!</a> Skús o5 o toľkoto sekúnd, keď sa vymažú mŕtve konce: ".$MAX_TIME_BEING_LOGGED_ON;
                }else{
                    $nicks=array();
                    $sql="select nick, time1 from users ORDER BY nick ASC LIMIT ".strval($MAX_CHATTERS_ALLOWED);
                    $result=run_query_quietly($sql,$conn);
                    if (mysqli_num_rows($result) > 0) {
                        while($row = mysqli_fetch_assoc($result)) {
                            $nick=trim($row["nick"]);
                            $logged_from=$row["time1"];
                            $has_rp_from_nick_to_session_nick=does_he_have_rp($nick,$servername,$username,$password,$database);
                            if(trim($_SESSION["nick"])!=trim($nick)) $nicks[]="<a target=\"_blank\" style=\"color:darkorange;\" href=\"rp.php?od=".trim($_SESSION["nick"])."&komu=".$nick."\"><spann>".$nick." [prihlásený_od: ".$logged_from."] <span style=\"color:red;\">ti píše RP:".$has_rp_from_nick_to_session_nick."</span>|</span></a><br>";
                        }
                    }
                    $nicks_stringified="";
                    for($i=0;$i<count($nicks);$i++){
                        $nicks_stringified.=$nicks[$i];
                    }
                    return $nicks_stringified;
                }

            }
    mysqli_close($conn);
}

//if you are over $MAX_RP_COUNT_ALLOWED, you just delete every msg2 in table rp where from_id, to_id is to_id, from_id
function overlapped_max_rp_count_allowed($from_id,$to_id,$MAX_RP_COUNT_ALLOWED,$servername,$username,$password,$database){
    $all_msg_count=0;
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    
    $sql="SELECT msg2 FROM rp WHERE from_id=".$from_id." AND to_id=".$to_id."";
    $result=run_query_quietly($sql,$conn);
    if (mysqli_num_rows($result) > 0){
        while($row = mysqli_fetch_assoc($result)) {
            $all_msg_count+=1;
        }
    }

    $sql="SELECT msg2 FROM rp WHERE from_id=".$to_id." AND to_id=".$from_id."";
    $result=run_query_quietly($sql,$conn);
    if (mysqli_num_rows($result) > 0){
        while($row = mysqli_fetch_assoc($result)) {
            $all_msg_count+=1;
        }
    }

    echo("<div style=\"background-color:pink;\">Zostáva vám obom napísať cca ".($MAX_RP_COUNT_ALLOWED-$all_msg_count+1)." správ a vymažem toto RP sklo.</div>");

    if ($all_msg_count>$MAX_RP_COUNT_ALLOWED){
        //if we are just over, we can delete all msgs in mutual thread:
            $sql="DELETE FROM rp WHERE from_id=".$from_id." AND to_id=".$to_id."";
            $result=run_query_quietly($sql,$conn);
            $sql="DELETE FROM rp WHERE from_id=".$to_id." AND to_id=".$from_id."";
            $result=run_query_quietly($sql,$conn);
    }

    mysqli_close($conn);
}

//this function consumes rp_msg and sends it to database based on from_id and to_id:
function send_rp_towards($rp_msg,$from_id,$to_id,$servername,$username,$password,$database){
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    $sql="INSERT INTO rp (from_id,to_id,msg2,seen) VALUES (".$from_id.",".$to_id.",'".trim($rp_msg)."','0')";
    $result=run_query_quietly($sql,$conn);
    mysqli_close($conn);
    echo("<div style=\"background-color:green;color:black;\">Tvoja správa sa odoslala. Sklo sa za 50s obnoví samo, ak ho neobnovíš ty, aby si videl najnovšie správy.</div>");
}

//this function shows thread
//here from_id is $GET[od]==better use SESSION[nick_id] id and to_id is $GET["komu"] id
function show_rp_thread($from_id,$to_id,$nick_from,$nick_to,$servername,$username,$password,$database,$MAX_RP_COUNT_ALLOWED,$MAX_LEN_MSG_RP){
    echo("<div style=\"background-color:pink;\">Pre načítanie nových správ a obnovenie tohoto RP skla <a style=\"color:green;\" href=\"rp.php?od=".$nick_from."&komu=".$nick_to."\">KLIK SEM</a></div>");
    overlapped_max_rp_count_allowed($from_id,$to_id,$MAX_RP_COUNT_ALLOWED,$servername,$username,$password,$database); //first I check if we overlapped max RP msgs count in thread
    //just message on the rp thread page:
    echo("<div style=\"background-color:pink;\">Kto si píše? ".$nick_from."<->".$nick_to." a ty si prihlásený/á ako ".$_SESSION["nick"]." a máš RP:".does_he_have_rp($nick_to,$servername,$username,$password,$database)."</div>");//here I use (does he have rp) func to update timestamp of logged on users writing anything anywhere
    echo("<div style=\"background-color:white;\">---------------------------------------------------</div>");
    echo("<div style=\"background-color:lightgreen;\">[On/ona ti píše:]</div>");

    
    $conn=open_conn_with_db_quietly($servername,$username,$password,$database);
    
    //he writes to you
    $he_writes_to_you=array();
    $he_writes_to_you_time2=array();
    $sql="SELECT msg2, time2 FROM rp WHERE from_id=".$to_id." AND to_id=".$from_id." ORDER BY time2 ASC";
    $result=run_query_quietly($sql,$conn);
    if (mysqli_num_rows($result) > 0){
        while($row = mysqli_fetch_assoc($result)) {
            $he_writes_to_you[]=$row["msg2"];
            $he_writes_to_you_time2[]=$row["time2"];
        }
    }

    $he_writes_to_you_stringified="";
    for($i=0;$i<count($he_writes_to_you);$i++){
        $he_writes_to_you_stringified.="<div style=\"background-color:lightgreen;\">Správa[".($i+1)."]: [".$he_writes_to_you_time2[$i]."] ".$he_writes_to_you[$i]."</div>";
    }
    
    echo($he_writes_to_you_stringified);

    //you write to him:
    echo("<div style=\"background-color:white;\">---------------------------------------------------</div>");
    echo("<div style=\"background-color:yellow;\">[Ty píšeš jemu/jej:]</div>");
    $he_writes_to_you=array();
    $he_writes_to_you_time2=array();
    $sql="SELECT msg2, time2 FROM rp WHERE from_id=".$from_id." AND to_id=".$to_id." ORDER BY time2 ASC"; //it is the same only here change to/from
    $result=run_query_quietly($sql,$conn);
    if (mysqli_num_rows($result) > 0){
        while($row = mysqli_fetch_assoc($result)) {
            $he_writes_to_you[]=$row["msg2"];
            $he_writes_to_you_time2[]=$row["time2"];
        }
    }

    $he_writes_to_you_stringified="";
    for($i=0;$i<count($he_writes_to_you);$i++){
        $he_writes_to_you_stringified.="<div style=\"background-color:yellow;\">Správa[".($i+1)."]: [".$he_writes_to_you_time2[$i]."] ".$he_writes_to_you[$i]."</div>";
    }
    
    echo($he_writes_to_you_stringified);

    //now we need to have input prompt for writing to him/her an rp
    echo("<div style=\"background-color:white;\">---------------------------------------------------</div>");
    echo("<form style=\"margin:10px;padding:10px;\" action=\"rp.php?od=".$nick_from."&komu=".$nick_to."\" method=\"post\"> <input autocomplete=\"off\" style=\"width:70%;\" type=\"text\" name=\"rpcka\" maxlength=180><input type=\"submit\" value=\">Pošli RP>\"> </form>");

    if(isset($_POST["rpcka"]) && trim($_POST["rpcka"])!="" && check_msg_len_allow(trim($_POST["rpcka"]),$MAX_LEN_MSG_RP)){
        
        //echo($_POST["rpcka"]);//here only call function which consumes POST[rpcka] and writes it to rp table based on from_id and to_id:
        send_rp_towards(substr(trim($_POST["rpcka"]),0,$MAX_LEN_MSG_RP),$from_id,$to_id,$servername,$username,$password,$database);//sending rp to database from_id towards to_id
    
    }else{
        echo("<div style=\"background-color:red;color:white;\">Nedá sa poslať prázdna RPčka! RPčka smie obsahovať znaky A-Z a-z 0-9 _ medzera.</div>");
    }

    mysqli_close($conn);
}

//this function just checks whether any nick in primary table users has a double:
//and this function then tries to repair database iterator:
function if_overflew_iterator(){
 //https://dev.mysql.com/doc/refman/8.0/en/out-of-range-and-overflow.html
 //not necessary, throws an error, ok then
}

?>